/* Sistemas Integrados TECNISA

Nome: 9814_CDPTRGO_LOG_CDP_FOTOESPEPROD.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato
*/

/* Tabela FOTOESPEPROD.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              FOTOESPEPROD, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_CDP_FOTOESPEPROD
AFTER DELETE OR INSERT OR UPDATE
ON FOTOESPEPROD FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(300);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;

         IF :NEW.CDESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEspecificProd= ' || NVL(:NEW.CDESPEPROD,'') || ' ';
         END IF;

         IF :NEW.NRFGESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'NrSequencialFotoEspProd= ' || NVL(:NEW.NRFGESPEPROD,'')  || ' ';
         END IF;
         
         IF :NEW.IDFGESPEATIV IS NOT NULL THEN
            V_DESC := V_DESC || 'IdFotoAtivaEspProd= ' || NVL(:NEW.IDFGESPEATIV,'') || ' ';
         END IF;

         IF :NEW.IDAJUSFGESPE IS NOT NULL THEN
            V_DESC := V_DESC || 'IdAjusteFotoTela= ' || NVL(:NEW.IDAJUSFGESPE,'') || ' ';
         END IF;
                  
      V_ITPESQ := :NEW.CDPRODUTO    || :NEW.CDESPEPROD || :NEW.NRFGESPEPROD || :NEW.IDFGESPEATIV ||
                  :NEW.IDAJUSFGESPE;
                  
      V_IDTIPOOPER := '1';  

   END IF;

      IF UPDATING THEN

         IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;

         IF (:NEW.CDESPEPROD <> :OLD.CDESPEPROD) THEN
            V_DESC := V_DESC || 'CdEspecificProd= ' || NVL(:NEW.CDESPEPROD,'') || ' ';
         END IF;

         IF (:NEW.NRFGESPEPROD <> :OLD.NRFGESPEPROD) THEN
            V_DESC := V_DESC || 'NrSequencialFotoEspProd= ' || NVL(:NEW.NRFGESPEPROD,'')  || ' ';
         END IF;
         
         IF (:NEW.IDFGESPEATIV <> :OLD.IDFGESPEATIV) THEN
            V_DESC := V_DESC || 'IdFotoAtivaEspProd= ' || NVL(:NEW.IDFGESPEATIV,'') || ' ';
         END IF;

         IF (:NEW.IDAJUSFGESPE <> :OLD.IDAJUSFGESPE) THEN
            V_DESC := V_DESC || 'IdAjusteFotoTela= ' || NVL(:NEW.IDAJUSFGESPE,'') || ' ';
         END IF;

      V_ITPESQ := :NEW.CDPRODUTO    || :NEW.CDESPEPROD || :NEW.NRFGESPEPROD || :NEW.IDFGESPEATIV ||
                  :NEW.IDAJUSFGESPE;

          V_IDTIPOOPER := '2';    
          
      END IF; 

   IF DELETING  THEN

         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:OLD.CDPRODUTO,'') || ' ';
         END IF;

         IF :OLD.CDESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEspecificProd= ' || NVL(:OLD.CDESPEPROD,'') || ' ';
         END IF;

         IF :OLD.NRFGESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'NrSequencialFotoEspProd= ' || NVL(:OLD.NRFGESPEPROD,'')  || ' ';
         END IF;
         
         IF :OLD.IDFGESPEATIV IS NOT NULL THEN
            V_DESC := V_DESC || 'IdFotoAtivaEspProd= ' || NVL(:OLD.IDFGESPEATIV,'') || ' ';
         END IF;

         IF :OLD.IDAJUSFGESPE IS NOT NULL THEN
            V_DESC := V_DESC || 'IdAjusteFotoTela= ' || NVL(:OLD.IDAJUSFGESPE,'') || ' ';
         END IF;
                  
      V_ITPESQ := :OLD.CDPRODUTO    || :OLD.CDESPEPROD || :OLD.NRFGESPEPROD || :OLD.IDFGESPEATIV ||
                  :OLD.IDAJUSFGESPE;
                  
      V_IDTIPOOPER := '3';
      
   END IF;   

   IF NOT (V_DESC IS NULL) THEN
      
      INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                             DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                   VALUES  ('FOTOESPEPROD', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                             V_IDTIPOOPER,   V_DESC, V_ITPESQ,
                             V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                             V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER);
      
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_FOTOESPEPROD','5.07.001'); END;
/  
